<script setup>
import { computed, ref } from "vue";
import { useStore } from "vuex";
import { minimalObject, i18n } from "@utils";
import { cloneDeep } from "lodash";
import FoldOut from "@components/Template/FoldOut.vue";
import ModalOverlay from "@components/Template/ModalOverlay.vue";

const store = useStore();

store.dispatch("collections/getAll");

// Compute necessary Store values for Component
const game = computed(() => store.state.game.selected);
const names = computed(() => store.state.collections.names);
const data = computed(() => store.state.collections.documents);
const schema = computed(() => store.state.collections.schema);

const defaultModal = {
  visible: false,
  onConfirm: undefined, // function to call by confirm button in modal
  onDismiss: () => (modal.value.visible = false), // function to call by cancel button in modal
  title: "...",
  text: "...",
  confirmButtonText: "Confirm",
  dismissButtonText: "Cancel",
  style: "is-info", // delete or add
  mode: "", // input gives modal with input field
  value: undefined, // value from input field
  originValue: undefined, // old value for setting initial text
};

const modal = ref({ ...defaultModal });

function setModal(args) {
  modal.value = Object.assign(modal.value, defaultModal, { visible: true, originValue: args?.value || "" }, args);
}

function getMinimalItem(collection) {
  const baseSchema = cloneDeep(schema.value[collection]);
  const allKeysSchema = Object.assign(baseSchema, {
    required: Object.keys(schema.value[collection].properties),
  });
  const document = minimalObject(allKeysSchema);
  const filteredDocument = filterUnsafeKeys(document);
  return filteredDocument;
}

function filterUnsafeKeys(document) {
  // prettier-ignore
  const unsafeKeys = ["_id","created_at","modified_at","created_by","modified_by","created_with","modified_with","sessions"];
  return Object.keys(document)
    .filter((key) => unsafeKeys.indexOf(key) === -1)
    .reduce((cur, key) => {
      return Object.assign(cur, { [key]: document[key] });
    }, {});
}

function restoreUnsafeKeys(original, modified) {
  // prettier-ignore
  const unsafeKeys = ["_id","created_at","modified_at","created_by","modified_by","created_with","modified_with","sessions"];
  if (typeof modified === "string") {
    try {
      modified = JSON.parse(modified);
    } catch (error) {
      const message = i18n("ERROR.JSONCONVERT", { error: error.toString() });
      store.dispatch("adaptor/addLog", { type: "error", message });
      return undefined;
    }
  }
  unsafeKeys.forEach((key) => {
    if (key in original) modified[key] = original[key];
  });
  return modified;
}

function getDocuments(collection) {
  store.dispatch("collections/getDocuments", { collection });
}

function createDocument(collection) {
  store
    .dispatch("collections/createDocument", {
      collection,
      document: modal.value.value,
    })
    .then(() => setModal({ visible: false }));
}

function updateDocument(collection, oldDocument) {
  const id = oldDocument._id;
  const data = restoreUnsafeKeys(oldDocument, modal.value.value);
  if (data) {
    store.dispatch("collections/updateDocument", { collection, id, data }).then(() => setModal({ visible: false }));
  }
}

function deleteDocument(collection, document) {
  store.dispatch("collections/deleteDocument", { collection, document }).then(() => setModal({ visible: false }));
}

// this function copies text to clipboard
function copyDocument(collection, document) {
  const jsonString = JSON.stringify(document, null, 2);
  navigator.clipboard.writeText(jsonString)
    .then(() => {
      store.dispatch("adaptor/addLog", { 
        type: "success", 
        message: `Document from ${collection} copied to clipboard` 
      });
    })
    .catch(err => {
      store.dispatch("adaptor/addLog", { 
        type: "error", 
        message: `Failed to copy document: ${err}` 
      });
    });
    setModal({ visible: false });
}

function createCollection() {
  store.dispatch("collections/createCollection", { name: modal.value.value }).then(() => setModal({ visible: false }));
}

function deleteCollection(collection) {
  store.dispatch("collections/deleteCollection", { collection }).then(() => setModal({ visible: false }));
}
</script>

<template>
  <div class="is-scroll-container is-flex is-flex-direction-column has-background-purple-5 px-2">
    <h1 class="title is-5">Collections {{ game }}</h1>
    <FoldOut
      v-for="collection in names"
      :key="collection"
      class="has-background-white has-border m-2"
      @on-open="getDocuments(collection)"
    >
      <template #header>
        <div class="p-1">
          <nav class="level is-interactive">
            <!-- Left side -->
            <div class="level-left ml-1">
              <div class="level-item">
                <p class="subtitle">
                  {{ collection }}
                </p>
              </div>
            </div>
            <!-- Right side -->
            <div class="level-right">
              <p class="level-item is-danger">
                <a
                  class="has-text-danger"
                  @click.stop="
                    setModal({
                      title: 'Delete Collection',
                      text: `Do you really want do delete the Collection ${collection}?`,
                      confirmButtonText: `Delete ${collection}`,
                      style: 'is-danger',
                      onConfirm: () => deleteCollection(collection),
                    })
                  "
                >
                  Delete Collection
                </a>
              </p>
              <p class="level-item">
                <!-- Replace with formdefault or fix minimalObject helper function -->
                <a
                  class="button is-success"
                  @click.stop="
                    setModal({
                      title: 'Create Document',
                      text: `Create new Document in Colletction ${collection}?`,
                      value: getMinimalItem(collection),
                      confirmButtonText: 'Create',
                      onConfirm: () => createDocument(collection),
                      mode: 'multiline',
                      editable: true,
                    })
                  "
                >
                  Add Document
                </a>
              </p>
            </div>
          </nav>
        </div>
      </template>
      <template #default>
        <div class="collection-table-container">
          <!-- TABLES -->
          <table v-if="data[collection] && data[collection].length > 0" class="table is-striped is-bordered">
            <thead>
              <tr>
                <th class="actions-cell has-background-light">actions</th>
                <th v-for="(value, key) in schema[collection].properties" :key="`${collection}_key_${key}`">
                  {{ key }}
                </th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="document in data[collection]" :key="document._id">
                <td class="actions-cell has-background-white">
                  <div class="field is-grouped is-grouped-multiline">
                    <div class="field is-grouped">
                    <p class="control">
                      <a
                        class="button is-small is-rounded is-light"
                        @click.stop="
                          setModal({
                            title: `Document ${document._id}`,
                            text: `Document ${document._id} in Colletction ${collection}?`,
                            value: JSON.stringify(document, null, 2),
                            confirmButtonText: 'Copy to Clipboard',
                            onConfirm: () => copyDocument(collection, document),
                            mode: 'multiline',
                            editable: false
                          })
                        "
                      >
                        <Icon class="has-text-dark" :icon="'file'" tooltip="View Document"/>
                      </a>
                    </p>
                    <p class="control">
                      <a
                        class="button is-small is-rounded is-light"
                        @click.stop="
                          setModal({
                            title: 'Update Document',
                            text: `Update Document ${document._id} in Colletction ${collection}?`,
                            value: JSON.stringify(filterUnsafeKeys(document), null, 2),
                            confirmButtonText: 'Update',
                            onConfirm: () => updateDocument(collection, document),
                            mode: 'multiline',
                            editable: true,
                          })
                        "
                      >
                        <Icon class="has-text-dark" :icon="'edit'" tooltip="Edit Document"/>
                      </a>
                    </p>
                  </div>
                    <p class="control">
                      <a
                        class="button is-small is-rounded is-light"
                        @click.stop="
                          setModal({
                            title: 'Delete Document',
                            text: `Do you really want do delete the Document ${document._id}?`,
                            confirmButtonText: `Delete`,
                            style: 'is-danger',
                            onConfirm: () => deleteDocument(collection, document._id),
                          })
                        "
                      >
                        <Icon class="has-text-danger" :icon="'trash-2'" tooltip="Delete Document"/>
                      </a>
                    </p>
                  </div>
                </td>
                <td v-for="(value, key) in schema[collection].properties" :key="`${document._id}_${key}`">
                  <span class="has-text-lines-5">{{ document?.[key] ?? "" }}</span>
                </td>
              </tr>
            </tbody>
          </table>
          <!-- LOADING TABLE -->
          <a v-else-if="!data[collection]" class="button is-loading is-fullwidth">Loading</a>
          <!-- NO DATA IN TABLE -->
          <span v-else class="m-3 content">No data in Collection {{ collection }}.</span>
        </div>
      </template>
    </FoldOut>
    <!-- ADD BUTTON -->
    <section>
      <button
        class="button is-dark m-2"
        @click.stop="
          setModal({
            title: 'New Collection',
            text: 'Give your new Collection a name.',
            confirmButtonText: 'Create',
            onConfirm: () => createCollection(),
            mode: 'input',
            editable: true,
          })
        "
      >
        New Collection
      </button>
    </section>
  </div>

  <!-- MODAL -->
  <ModalOverlay v-if="modal.visible" :modal="modal" :css-classes="[modal.style]" @close-modal="modal.visible = false">
    <template #header>{{ modal.title }}</template>
    <template v-if="modal.mode == 'input'" #default>
      <label class="has-text-pre-wrap" for="value">{{ modal.text }}</label>
      <input v-model="modal.value" class="input" type="text" name="value" />
    </template>
    <template v-else-if="modal.mode == 'multiline'" #default>
      <label for="value">{{ modal.text }}</label>
      <pre class="has-text-black" :contenteditable="modal.editable" @input="modal.value = $event.target.textContent">{{
        modal.originValue
      }}</pre>
    </template>
    <template v-else #default>
      <label for="value">{{ modal.text }}</label>
    </template>
    <template #footer>
      <button class="button m-1" :class="modal.style" @click="modal.onConfirm">
        {{ modal.confirmButtonText }}
      </button>
      <button class="button m-1" @click="modal.onDismiss">
        {{ modal.dismissButtonText }}
      </button>
    </template>
  </ModalOverlay>
</template>

<style scoped>
.actions-cell {
  position: sticky;
  left: 0;
  box-shadow: 2px 0 5px rgba(0, 0, 0, 0.1);
}
</style>
